package QNetwork;

//Questa classe definisce l'oggetto rete di code
class QNet {
	
	private double service[][];  //tassi di servizio per ogni nodo e catena
    private double arrives[][];  //tassi di arrivo per ogni nodo e catena
	private double routing[][][];//tabelle di routing di ogni catena
	private int nodes, chains;   //cardinalita' dei nodi e delle catene
	private double lambdar[][];	 //lambda per ogni nodo di ogni catena
	private double lambda[];	 //lambda totale per ogni nodo
	private int [] capacity;     //capacita' dei nodi
	private double goOutProb[][];//la probabilita' che il un cliente,terminato
							 	 //l'utilizzo di un nodo,esca dalla rete
	
	public QNet(int nodi, int nchains, double rout[][][], double servRate[][],double arRate[][],int cap[]){
	int i,j;
    nodes = nodi;
    chains = nchains;
    service = servRate;
    routing = rout;
    arrives=arRate;
    capacity=cap;
    lambdar = new double[chains][nodes];
    for(i=0;i<chains;i++)
    	lambdarCalculator(i); 
    lambda = new double[nodes];
    for(i=0;i<nodes;i++)	//inizializzo tutto a zero
    	lambda[i]=0;
    for(i=0;i<nodes;i++)	//sommo gli input per tutte le catene
    	for(j=0;j<chains;j++)
    		lambda[i]+=lambdar[j][i]; 
    goOutProb = new double[chains][nodes];
    for(i=0;i<chains;i++)
    	for(j=0;j<nodes;j++)
    		initOutProb(i,j);
    }
    
    private void initOutProb(int chain,int node){
    	double prob = 0;
    	for(int i=0;i<nodes;i++)
    		prob += routing[chain][node][i];
        goOutProb[chain][node]=1-prob;	
    }
    
	private void lambdarCalculator(int chain){
		int i,j;
		for(i=0;i<nodes;i++){
			lambdar[chain][i] = arrives[i][chain];
			for(j=0;j<i;j++)
				lambdar[chain][i] = lambdar[chain][j]*routing[chain][j][i];
		}
	}		

	public double getOutProb(int chain, int node){
		return goOutProb[chain][node];
	}
	public double getLambdaR(int node, int chain){
		return lambdar[chain][node];
	}
	
	public double getLambda(int node){
		return lambda[node];
	} 
	
	public int getCapacity(int node){
		return capacity[node];
	}
	
	public double getServiceRate(int node, int chain){
		return service[node][chain];
	}
	public double getArriveRate(int node, int chain){
		return arrives[node][chain];
	}	
	
	public double getProb(int chain, int row, int column)
	{
		return routing[chain][row][column];
	}	
	
	public int getChains()
	{
		return chains;
	}	
	
		public int getNodes()
	{
		return nodes;
	}	
}
