package QNetwork;

import java.awt.image.*;
//import javax.imageio.*;
import java.io.*;
import java.awt.geom.*;
import java.awt.Point;
import java.awt.image.WritableRaster;
import java.util.*;

public class Tester {
	
    private int node;
    private int nchains;
    private double [][][] router;
    private double [][] serviceRate;
    private double [][] arriveRate;
    private int [] capacity;
    private Result results;
    
    public Tester(){
    	
    }
    
    private void printResults(Analyser analizzatore){
        int i,j,k,bound=0;
        double codamedia=0;
        System.out.println("La rete e' stata risolta in " + results.getNIter() + " iterazioni.");
        for(i=0;i<node;i++){
            if(capacity[i]==-1)
                bound=50;
            else 
                bound = capacity[i]+1;
            for(k=0;k<=bound;k++){
                // if(i==1)
                //     System.out.println("qui");
                if((capacity[i]!=-1 && k<=bound) || (capacity[i]==-1 && k<6))
                    System.out.print("Nodo " + i + " P("+ k + "):");
                System.out.print(" " + results.getPi(i,k,analizzatore)+"\n");
                
                codamedia += k* results.getPi(i,k,analizzatore);
            
                //System.out.print(" " + results.getPiR(i,j,1));
                // System.out.print("\n");
            

            }
            
            System.out.println("L "+i+":"+codamedia);
            System.out.println("X "+i+":"+results.getX(i));
            codamedia=0;
        }
    }
    
    public void setup(String path){
        try{
            java.io.BufferedReader in = new java.io.BufferedReader(new FileReader(path));
            String line, number;
            StringTokenizer st;
            int i,j,k;
            //numero di catene
            line=in.readLine();
            nchains = Integer.parseInt(line);
            //numero di nodi
            line=in.readLine();
            node = Integer.parseInt(line);
        
            router = new double[nchains][node][node]; //non considero il routing per l'esterno! (correggere la vecchia implementazione)
            serviceRate = new double[node][nchains];
            arriveRate = new double[node][nchains];
            capacity = new int[node];
            //inizializzo le tabelle di routing
            for(k=0;k<nchains;k++){
        	for(i=0;i<node;i++){
                    line = in.readLine();
                    st = new StringTokenizer(line);
                    for(j=0;j<node;j++)
                        router[k][i][j] = Double.parseDouble(st.nextToken());
        	}	
            }
            //inizializzo il rate degli arrivi
            for(k=0;k<nchains;k++){
        	line = in.readLine();
        	st = new StringTokenizer(line);
        	for(j=0;j<node;j++)
                    arriveRate[j][k] = Double.parseDouble(st.nextToken());
            }
            //inizializzo il service rate
            for(k=0;k<nchains;k++){
        	line = in.readLine();
        	st = new StringTokenizer(line);
        	for(j=0;j<node;j++)
                    serviceRate[j][k] = Double.parseDouble(st.nextToken());
            }

        
            line = in.readLine();
            st = new StringTokenizer(line);
            for(j=0;j<node;j++)
        	capacity[j] = Integer.parseInt(st.nextToken());   	
    
        }catch(Exception e){
            System.out.println("Errore: "+e);
        }
    }
   
    
    public void start(){
        //Result risultato;
        Analyser analizzatore;
        QNetwork.QNet rete;
        try{
            rete = new QNet(node,nchains,router,serviceRate,arriveRate,capacity);
            analizzatore = new Analyser(rete);
            //analizzatore.analyzeNow();
            results=analizzatore.analyzeNow();
            printResults(analizzatore);
        
        } catch (java.lang.IllegalMonitorStateException e) {
        	
        }
        
    }
    
    
    public static void main(String[] args) {

        Tester test = new Tester();
        
        //test.setup("C:\\temp\\temp.txt");
        test.setup(args[0]);
        
        test.start();
        
    }
}
