package QNetwork;

import java.awt.image.*;
//import javax.imageio.*;
import java.io.*;
import java.awt.geom.*;
import java.awt.Point;
import java.awt.image.WritableRaster;
import java.util.*;

public class Tester3 {
	
	private int node;
	private int nchains;
	private double [][][] router;
	private double [][] serviceRate;
	private double [][] arriveRate;
	private int [] capacity;
        
        private double [][][] P ={
            {{0  ,0.5,0.5,0  },
              {0  ,0  ,0.5,0.5},
              {0  ,0  ,0  ,0.5},
              {0  ,0  ,0  ,0  }},
            {{0  ,1  ,0  ,0  },
              {0  ,0  ,0.7,0.3},
              {0  ,0  ,0  ,1},
              {0  ,0  ,0  ,0  }},
            {{0  ,0.3,0.7,0  },
              {0  ,0  ,0.7,0.3},
              {0  ,0  ,0  ,0.5},
              {0  ,0  ,0  ,0  }}
        };
        
        private int [][] B = {{-1,4,4,4},{4,4,4,4}};
        private double [][] mi = {
            {5,5,5,5},
            {5,3,5,5},
            {5,5,3,5}
        };
        private double [][][] lambda;
        private Result results;
    
    public Tester3(){
        node = 4;
        nchains = 2;  
        int i,j,k;
        lambda = new double[2][4][2]; 
        for(i=0;i<2;i++)
            for(j=0;j<4;j++)
                for(k=0;k<2;k++)
                    lambda[i][j][k]=0;
        lambda[0][0][0]=2;
        lambda[0][0][1]=1.5;
        lambda[1][0][0]=1.5;
        lambda[1][0][1]=2;
    }
    
    private void printResults(Analyser analizzatore, FileWriter out)
        throws IOException {
        int i,j,k,bound=0;
        double codamedia=0;
        System.out.println("La rete e' stata risolta in " + results.getNIter() + " iterazioni.");
        out.write("Risolta in " + results.getNIter() + " iterazioni.\n");
        for(i=0;i<node;i++){
            if(capacity[i]==-1)
                bound=100;
            else 
                bound = capacity[i]+1;

            for(k=0;k<bound;k++){

                if((capacity[i]!=-1 && k<=bound) || (capacity[i]==-1 && k<6))
                    System.out.print("Nodo " + i + " P("+ k + "):");
            
                codamedia += k* results.getPi(i,k,analizzatore);
            
            
                //System.out.print(" " + results.getPiR(i,j,1));
                if((capacity[i]!=-1 && k<=bound) || (capacity[i]==-1 && k<6))
                    System.out.print("\n");
                //out.write("\n");

            }
            
            System.out.println("L "+i+":"+codamedia);
            out.write("L "+i+":"+codamedia + "\n");
            System.out.println("X "+i+":"+results.getX(i));
            out.write("X "+i+":"+results.getX(i)+"\n");
            codamedia=0;
        }
    }
    
    public void setup(String path){
        try{
    	java.io.BufferedReader in = new java.io.BufferedReader(new FileReader(path));
  		String line, number;
  		StringTokenizer st;
  		int i,j,k;
  		//numero di catene
    	line=in.readLine();
    	nchains = Integer.parseInt(line);
    	//numero di nodi
        line=in.readLine();
        node = Integer.parseInt(line);
        
        router = new double[nchains][node][node]; //non considero il routing per l'esterno! (correggere la vecchia implementazione)
        serviceRate = new double[node][nchains];
        arriveRate = new double[node][nchains];
        capacity = new int[node];
        //inizializzo le tabelle di routing
        for(k=0;k<nchains;k++){
        	for(i=0;i<node;i++){
        		line = in.readLine();
        		st = new StringTokenizer(line);
        		for(j=0;j<node;j++)
        			router[k][i][j] = Double.parseDouble(st.nextToken());
        	}	
        }
        //inizializzo il rate degli arrivi
        for(k=0;k<nchains;k++){
        	line = in.readLine();
        	st = new StringTokenizer(line);
        	for(j=0;j<node;j++)
        		arriveRate[j][k] = Double.parseDouble(st.nextToken());
        }
        //inizializzo il service rate
        for(k=0;k<nchains;k++){
        	line = in.readLine();
        	st = new StringTokenizer(line);
        	for(j=0;j<node;j++)
        		serviceRate[j][k] = Double.parseDouble(st.nextToken());
        }

        
        line = in.readLine();
        st = new StringTokenizer(line);
        for(j=0;j<node;j++)
        	capacity[j] = Integer.parseInt(st.nextToken());   	
    
        }catch(Exception e){
            System.out.println("Errore: "+e);
        }
    }
   
    
    public void start(){
        //Result risultato;
        Analyser analizzatore;
        QNetwork.QNet rete;
        int i,j,m,n,k,temp,count=0;
               try{
        File outputFile = new File("outagain2.txt");
        FileWriter out = new FileWriter(outputFile);
        for(n=0;n<lambda.length;n++)
            for(j=0;j<mi.length;j++)                  
                for(i=0;i<B.length;i++)
                    for(m=0;m<P.length;m++)
                    {

                        capacity = B[i];
                        arriveRate = lambda[n];
                        serviceRate = new double[node][nchains];
                        for(k=0;k<node;k++){
                          if(j+1<mi.length)
                              temp=j+1;
                          else temp=0;
                          serviceRate[k][0] = mi[j][k];
                          serviceRate[k][1] = mi[temp][k];
                        }
                        router = new double[2][][];
                        router[0] = P[m];
                        if(m+1<P.length)
                            router[1] = P[m+1];
                        else
                            router[1] = P[0];
                        out.write(count + " # " + "lambda="+n+" mi="+j+" B="+i+" P="+m+" ");
                        rete = new QNet(node,nchains,router,serviceRate,arriveRate,B[i]);
                        analizzatore = new Analyser(rete);
                        results = analizzatore.analyzeNow();
                        printResults(analizzatore,out);
                        count++;
                }
        out.close();
        } catch (java.lang.IllegalMonitorStateException e) {
        	
                }catch(Exception e){
            System.out.println("Errore: "+e);
        }
        
    }
    
    
    public static void main(String[] args) {

        Tester3 test = new Tester3();
        
        //test.setup("C:\\temp\\temp.txt");
       // test.setup("C:\\newQN\\QNetwork\\tableVIII.txt");
        
        test.start();
        
    }
}
