#!/usr/bin/perl

my @lambdas=( 2, 1.5 );
my @mus=( [5,5,5,5], [5,3,5,5], [5,5,3,5] );
my @Bs=( [-1,5,5,5], [5,5,5,5] );
my @Ps=( [0.5, 0.5, 0.5], [0, 0.3, 0], [0.7, 0.3, 0.5] );
my $runn = 0;
my $startfrom = 0;
my @flags = @ARGV;

open( RES, ">", "qn_result.txt" );
print RES "#exp\tCoda\tL(min,max)\n";

sub executeRun {
    my ($i, $lambda, $mu, $B, $P) = @_;

    my $filename = "qn_test_$i.qn";
    # my $cmdline = "./qn -l 5e4 -w 0.05 ";
    my $cmdline = "./qn -l 5e4 -w 0.1 -r 20 ";

    open( FILE, ">", $filename );
    print FILE "2\n"; # nclasses
    print FILE "4\n"; # nservers
    # topology: catena 1
    my $p13 = $Ps[$P]->[0];
    my $p24 = $Ps[$P]->[1];
    my $p30 = $Ps[$P]->[2];
    print FILE "0 ".(1-$p13)." $p13 0\n";
    print FILE "0 0 ".(1-$p24)." $p24\n";
    print FILE "0 0 0 ".(1-$p30)."\n";
    print FILE "0 0 0 0\n";
    # topology: catena 2
    $P1 = ($P+1) % 3;
    $p13 = $Ps[$P1]->[0];
    $p24 = $Ps[$P1]->[1];
    $p30 = $Ps[$P1]->[2];
    print FILE "0 ".(1-$p13)." $p13 0\n";
    print FILE "0 0 ".(1-$p24)." $p24\n";
    print FILE "0 0 0 ".(1-$p30)."\n";
    print FILE "0 0 0 0\n";
    
    # arrivi: catena 1
    print FILE "$lambdas[$lambda] 0 0 0\n";
    # arrivi: catena 2
    $lambda1 = ($lambda+1) % 2;
    print FILE "$lambdas[$lambda1] 0 0 0\n";
    
    # servizi: catena 1
    print FILE "$mus[$mu]->[0] $mus[$mu]->[1] $mus[$mu]->[2] $mus[$mu]->[3]\n"; 
    # servizi: catena 2
    $mu1 = ($mu + 1) % 3;
    print FILE "$mus[$mu1]->[0] $mus[$mu1]->[1] $mus[$mu1]->[2] $mus[$mu1]->[3]\n"; 
    
    # capacities
    print FILE "$Bs[$B]->[0] $Bs[$B]->[1] $Bs[$B]->[2] $Bs[$B]->[3]\n"; 
    close(FILE);
    # run the simulation
    print "Simulation $i begins...\n";
    print RES "$i # P=$P B=$B mu=$mu lambda=$lambda\n";
        open( SIM, "$cmdline $filename | tee current.log |" );
    while ( $linea = <SIM> ) {
        if ( $linea =~ /L_(\d)\s+(\S+)\s+(\S+)/ ) {
            print "Coda $1 Lunghezza $2 $3\n";
            print RES "\tL_$1\t";
            print RES "$2 $3\n";
        } elsif ( $linea =~ /\s+(P\S+)\s+(\S+)\s+(\S+)/ ) {
            print RES "\t\tP $1 $2 $3\n";
        } elsif ( $line =~ /X_(\d)\s+(\S+)\s+(\S+)/ ) {
	    print RES "\t\tX $1 $2 $3\n";
	}
    }
    close( SIM );
    print "ok\n";
}

# parse command line flag
if ( @flags != 0 ) {
    if ( $flags[0] == "--start" ) {
        $startfrom = $flags[1];
    }
}

print "Starting from $startfrom\n";

foreach $lambda ( 0..1 ) {
    foreach $mu ( 0..2 ) {
        foreach $B ( 0..1 ) {
            foreach $P ( 0..2 ) {
                if ( $runn >= $startfrom ) {
                    executeRun( $runn, $lambda, $mu, $B, $P );
                }
                $runn++;
            }
        }
    }
}
close( RES );
