/****************************************************************************
 *
 * qn_param.hh
 *
 * This file is part of libcppsim
 *
 * Copyright (C) 2004 Moreno Marzolla
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 ****************************************************************************/

#ifndef QN_PARAM_HH
#define QN_PARAM_HH

#include <vector>
#include "cppsim.hh"

typedef struct qn_param_struct {
    int maxRep;         // Maximum number of replications
    double confp;       // Confidence probability
    double confw;       // Confidence width
    double simLen;      // Sim. Length in time units
    bool doDebug;
    double trLen;       // Transient length

    std::vector< cppsim::timeweighted* > utilization;
    std::vector< cppsim::timeweighted* > realutilization;
    std::vector< cppsim::timeweighted* > queue_length;
    std::vector< cppsim::timewhisto* > queue_p;
    std::vector< cppsim::mean* > throughput;

} qn_param_struct;

#endif
