/****************************************************************************
 *
 * qn_source.hh
 *
 * This file is part of libcppsim
 *
 * Copyright (C) 2004 Moreno Marzolla
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 ****************************************************************************/

#ifndef QN_SOURCE_HH
#define QN_SOURCE_HH

#include <string>
#include "cppsim.hh"
#include "qn.hh"

//
// class Source
//
class source : public cppsim::process {
public:
    source( const std::string& name, int jclass, double jrate, int server_id );
    virtual ~source( );
protected:
    void inner_body( void );

    int _jclass; // job class
    cppsim::rng *_r; // rng
    int _sid; // server id   
};

#endif
