/*****************************************************************************
 *
 * dump.hh
 *
 * Dumps a sequence of observations X_0, X_1, \ldots X_N into a file
 * This file is part of libcppsim.
 *
 * Copyright (C) 2002, 2003, 2004 Moreno Marzolla
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *****************************************************************************/

#if HAVE_CONFIG_H
#include "config.h"
#endif 

#include <iostream>
#include <string>
#include "dump.hh"

namespace cppsim {

    using namespace std;

    dump::dump( const string& name, double confl ) :
        statistic( name, confl ),
        os( string(name+".dump").c_str() )
    {
        os << "# NumResets numUpdates value" << endl;
    }

    dump::~dump( )
    {

    }

    void dump::update( double v )
    {
        var_impl::update( v );
        os << numResets( ) << " " << numUpdates( ) << " " << v << endl << flush;
    }

    void dump::reset( void )
    {
        var_impl::reset( );
    }

}
