/****************************************************************************
 *
 * jain.hh
 *
 * This file is part of libcppsim
 *
 * Copyright (C) 2003 Moreno Marzolla
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 ****************************************************************************/

#ifndef _CPPSIM_JAIN_HH
#define _CPPSIM_JAIN_HH

#if HAVE_CONFIG_H
#include "config.h"
#endif

#include <vector>
#include <string>
#include "statistic.hh"

namespace cppsim {

    /**
     * This class implements Jain's method
     */
    class jain : public statistic {
    public:
        /**
           \param confl The desired confidence level (\f$0 \leq \texttt{confl} \leq 1\f$
         */
        jain( const std::string& name, double confl );
        virtual ~jain( );
        void update( double v );
        void reset( void );
        const std::vector< std::string > headers( void );
        const std::vector< std::string > entries( void );
    protected:
        confInt value( void );
        std::vector< std::vector<double> > _ob;
    };

}

#endif
