/****************************************************************************
 *
 * observable.cc
 *
 * This file is part of libcppsim
 *
 * Copyright (C) 2005 Moreno Marzolla
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 ****************************************************************************/

#include "observable.hh"
#include "observer.hh"
#include <functional>
#include <algorithm>

namespace cppsim {

    using namespace std;

    observable::observable( ) :
        _observers( )
    {

    };

    list< observer* > observable::getObservers( void ) const
    {
        return _observers;
    };

    void observable::registerObserver( observer* o )
    {
        _observers.push_back( o );
    };

    void observable::updateObservers( void )
    {
        for_each( _observers.begin(), _observers.end(),
                  mem_fun_t< void, observer >( & observer::update ) );
    };

}
