/****************************************************************************
 *
 * report.hh
 *
 * This file is part of libcppsim.
 *
 * Copyright (C) 2005 Moreno Marzolla
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 ****************************************************************************/
#ifndef _CPPSIM_REPORT_HH
#define _CPPSIM_REPORT_HH

#if HAVE_CONFIG_H
#include "config.h"
#endif

#include <string>
#include <list>

namespace cppsim {
    
    class reportable;

    class report {
    public:
        virtual ~report( ) { };
        // Modifiers
        void registerObj( reportable* o );
        virtual void print( void ) = 0;
        // Accessors
        const std::string& name( void ) const { return _name; };
    protected:
        report( const std::string& name ) :
            _name( name )
        { };
        std::string _name;
        std::list< reportable* > _registered;
    };
    
}

#endif
